#ifndef _PARSER_H_
#define _PARSER_H_

#include "grDB.h"
#include <cstring>
#include <iostream>

inline void ErrorOpenFile ( const string & fileName ) 
{
    cout << "Cannot open file : " << fileName << endl;
    exit( 1 );
}

class Parser
{
    public:
        void ReadAux( const string auxFile );
        void ReadAux( const char * auxFile );
        void ReadNode( Layout & layout );
        void ReadPlace( Layout & layout );
        void ReadNet( Layout & layout );
        void ReadShape( Layout & layout );
        void ReadRouteConfig( Layout & layout );
        void exportDesign( Layout & layout, double netsPercent );

    private:
        void exportNodes( Layout & layout );
        void exportPl( Layout & layout );
        void exportRoute( Layout & layout );
        void exportNet( Layout & layout, double netsPercent );
        void exportAux( Layout & layout );
        
        string _nodesFile;
        string _netsFile;
        string _wtsFile;
        string _plFile;
        string _sclFile;
        string _shapesFile;
        string _routeFile;

        string line, tmp;

        unsigned _origNumNodes;
};

#endif
